SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #OOStack
	instanceVariableNames: 'theUpperNode size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:53'!
initialize 
	"comment stating purpose of message"
	super initialize.
	theUpperNode := NullStackNode new.
	size:= 0.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:00'!
isEmpty
	"comment stating purpose of message"

	^ theUpperNode isEmpty! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:52'!
pop
	
	| upperContent  |
	
	upperContent := self top.
	theUpperNode:= theUpperNode getBottomNode.
	^ upperContent! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:53'!
push: anObject 

	|aNode|
	
	aNode:= RealStackNode new.
	aNode initializeWith: anObject over: theUpperNode.
	size:= size + 1.
	theUpperNode := aNode.
	 
	! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:55'!
size 
	^ size! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:51'!
top
	^ theUpperNode getContent! !

Object subclass: #StackNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

StackNode subclass: #NullStackNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NullStackNode methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 21:11'!
getBottomNode
	|anError|
	anError:= Error new.
	 ^anError ! !

!NullStackNode methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 21:22'!
getContent
	^ self error: 'Stack is empty'! !

!NullStackNode methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:00'!
isEmpty
	"comment stating purpose of message"

	^ true! !

StackNode subclass: #RealStackNode
	instanceVariableNames: 'nodeContent netherNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!RealStackNode methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:35'!
getBottomNode
	^netherNode ! !

!RealStackNode methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:49'!
getContent
	^ nodeContent ! !

!RealStackNode methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:43'!
initializeWith: anObject over: aStackNode 
	
	super initialize.
	
	nodeContent := anObject.
	netherNode := aStackNode ! !

!RealStackNode methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 20:35'!
isEmpty
	
	^false! !

!StackNode methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/8/2013 17:39'!
getBottomNode
	self subclassResponsibility ! !

!StackNode methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/8/2013 17:39'!
getContent
	self subclassResponsibility ! !

!StackNode methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/8/2013 17:40'!
isEmpty
	self subclassResponsibility ! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
